
Gar3D
April, 2017
AUTHOR: Jon Garbe.

Gar3D is a wrapper for SDL and openGL (also using glm) intended to make simple 3D graphics extremely easy to produce.
Produced for educational use in University of Minnesota csci 1113 course.

----------------------------------
TO USE:
----------------------------------

(if you don't want to write gar3d:: all over, just put using namespace gar3d; in your code)

drawing objects on the screen:

-declare a Gar3D object. resolution may be specified in the constructor.
-call .drawPrimitive(...) or .drawLine(...) to draw objects to the buffer.
-call .renderFrame() to display the buffered objects on the screen, clear the buffer, and update the input handler.

polling input:

-The input handle can be retrieved using .input()
-To poll for a particular key press (true only the first frame it is pressed), call .input().buttonPressed(...)
-Other input functions include .input().buttonHeld(...), .input().buttonReleased(...), and those same functions for mouse buttons: mouseButtonPressed(...), etc.
-The escape key is reserved. It sets the userQuit flag to true.



----------------------------------
NOTES:
----------------------------------

camera defaults to orbit mode.
other camera modes include pan and free. Orbit and pan cameras may be controlled by clicking and dragging on the window. Free camera allows you to manually set the location (.setFreeCameraPosition) and a point to look at (.setFreeCameraTarget).
To change mode, simply call .CameraMode(...).

----------------------------------
FUNCTION DESCRIPTIONS:
----------------------------------

class Gar3D:

drawPrimitive:
	adds a primitive object to the buffer, and displays it when renderFrame() is called
	
drawLine:
	adds a line object to the buffer, and displays it wen renderFrame() is called
	
deltaTime:
	returns time elapsed during previous frame
	
shouldQuit:
	returns true if the user pressed the quit key (escape)
	
input:
	return the input handle. input handle functions are described below.
	
color:
	gets or sets the color of objects added to the draw buffer
	
backgroundColor:
	get or set the background color of the window
	
lineSize:
	set the thickness of lines drawn by drawLine
	
renderFrame:
	displays all buffered objects on the screen, clears buffer, updates state of virtual input

(get/set)FreeCameraPosition:
	gets or sets the position of the camera if freecam is being used.
	
(get/set)FreeCameraTarget:
	gets or sets the point the camera looks at if freecam is being used
	
(get/set)PanCamera(Min/Max)Bounds:
	gets or sets the camera's maximum or minimum x, y, and z coordinates of the camera if pancam is being used

lightBrightness:
	get or set the brightness of the lights in the scene

-------------------------------

class InputHandle:

(mouse)ButtonHeld:
	returns true if the specified button is pressed

(mouse)ButtonPressed:
	returns true on the first frame the specified button is pressed
	
(mouse)ButtonReleased:
	returnsTrue on the first frame after the specified button is released
	
mousePosition:
	changes the parameters to the x and y coordinates of the mouse pointer
	
getMouseMotion:
	changes the parameters the the movement of the mouse during the previous frame
	
mouseX:
	returns x position of mouse cursor (pixels from left)

mouseY:
	returns y position of mouse cursor (pixels from top)
	

